'use strict';

/**
 * requestAnimationFrame 对动画的兼容
 */
var requestAnimationFrame =
  window.requestAnimationFrame ||
  window.mozRequestAnimationFrame ||
  function(callback) {
    return window.setTimeout(callback, 1000 / 60);
  };
/**
 * cancelAnimationFrame 对动画的兼容
 */
var cancelAnimationFrame =
  window.cancelAnimationFrame ||
  window.cancelRequestAnimationFrame ||
  window.mozCancelAnimationFrame ||
  function(id) {
    window.clearTimeout(id);
  };

module.exports = {
  'requestAnimationFrame': requestAnimationFrame,
  'cancelAnimationFrame': cancelAnimationFrame,
};