/**
 */
var merge = require('bcore/utils').merge;
var blending = require('./blending');
var format = require('./format');

/**
 * updateColorFunc 解析色彩
 * @param  {[type]} a 可以为对象 或colorFrom
 * @param  {[type]} b colorTo
 * @param  {String} c blendingType rgb或hsl 在哪个空间下插值
 * @param  {[type]} d easing函数或关键字符
 */

function getColorFunc(colorFrom, colorTo, blendingType, easing, defaults) {
  if (typeof(colorFrom) === 'function') {
    return colorFrom;
  } else if (typeof(colorFrom) === 'object' && !arguments[1]) {
    return blending(colorFrom.from, colorFrom.to, colorFrom.space, colorFrom.easing, colorFrom.default || colorFrom.none).toFunc();
  } else if (typeof(colorFrom === 'number')) {
    return function() {
      return colorFrom;
    };
  } else {
    return blending(colorFrom || '#0ff', colorTo || '#000', blendingType, easing, defaults).toFunc();
  }
}

module.exports = merge(format, {
  blending: blending,
  getColorFunc: getColorFunc
});