'use strict';
 var geohash = require('ngeohash');

 function Map(lat, lng){
  if(arguments.length) this.data(lat, lng);
 }

 Map.prototype.data = function(a, b){
  if(Array.isArray(a)) {
    this.lat = a[0];
    this.lng = a[1];
  } else if(typeof(lat) === 'object'){
    this.lat = a.lat;
    this.lng = a.lng;
  } else if(arguments.length === 2){
    this.lat = a;
    this.lng = b;
  }
 };

 Map.prototype.toGeohash = function(precision) {
  precision = precision || 9;
  return geohash.encode(this.lat, this.lng, precision);
 };

function map(lat, lng){
  return new Map(lat, lng);
}
module.exports = map;
