'use strict';
var Easing = require('./../easing');
var pow = Math.pow;


function Transition(easing) {
}

/**
 * easing 根据easing缩写字符(easing函数返回本身) 返回easing函数
 * @param  {String} easing easing字符/函数
 * @return {Function}        easing函数
 */
Transition.prototype.easing = function (easing) {
  var func;
  if (typeof (easing) === 'string') {
    easing = easing[0].toUpperCase() + easing.substring(1); //首字母大写
    var strs = easing.split('.');
    if (easing.indexOf('Linear') !== -1) {
      easing = Easing.Linear.None;
    } else {
      if (strs.length < 2) return console.log('easing不存在');
      if (Easing[strs[0]]) {
        easing = Easing[strs[0]][strs[1]];
      } else {
        return console.log('easing不存在');
      }
    }
    if (strs[2]) {
      var n = parseFloat(strs[2], 10);
      func = function (k) {
        return pow(easing(k), n);
      };
    }
  }
  this.func = func || easing;
  return this;
};

Transition.prototype.toFunc = function () {
  return this.func;
};

function transition(){
  return new Transition();
}

// console.log(parseColor('#0ff'),parseColor('#00ffff'),parseColor('rgb(0,255,255)'),parseColor('rgba(0,255,255,1)'),parseColor('hsl(180,100%,50%)'),parseColor('hsla(180,100%, 50%, 0.5)'));
module.exports = transition;

