var Event = require('bcore/event');

/**
 * <h3>可视化基类</h3>
 * <p>dchart, dmap都集成于此类，用户创建的可视化图必须是此类的子类，并且要实现下列方法</p>
 * @class
 */
function View() {
  this._data = null;
}

Event.extend(View, {
  /**
   * 初始化
   */
  init : function () {},
  /**
   * 获取或设置数据
   * @param data
   * @returns {null|*}
   */
  data : function (data) {
    if (data) {
      this._data = data;
    } else {
      return this._data;
    }
  },
  /**
   * 绘制
   * @param data 绘制的数据
   */
  render : function (data) {

  },
  /**
   * 调整大小
   */
  resize : function () {},
  /**
   * 更新
   */
  update : function () {},
  /**
   * 销毁
   */
  destroy : function () {}
});

module.exports = View;